Index: trunk/doc/manual/en_US/dita/UserManual.ditamap
===================================================================
--- trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 106219)
+++ trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 106318)
@@ -616,4 +616,5 @@
          <topicref href="topics/secure-config-vms.dita">
             <topicref href="topics/security-networking.dita"/>
+        <topicref href="topics/security-of-remote-vms.dita"/>
             <topicref href="topics/security-vrdp-auth.dita"/>
             <topicref href="topics/security_clipboard.dita"/>
Index: trunk/doc/manual/en_US/dita/topics/create-optical-disk-image.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/create-optical-disk-image.dita	(revision 106219)
+++ trunk/doc/manual/en_US/dita/topics/create-optical-disk-image.dita	(revision 106318)
@@ -4,6 +4,6 @@
   <title>Creating a Virtual Optical Disk Image</title>
   <body>
-    <p>Use the <b outputclass="bold">VISO Creator</b> tool to create a virtual optical disk image. This enables you to
-      create a virtual ISO from selected files on the host. </p>
+    <p>Use the <b outputclass="bold">VISO Creator</b> tool to create a virtual optical disk image from selected files on the host. </p>
+    <p>A virtual ISO (VISO) differs from a real ISO because the files remain on the host, unless you choose to copy the files to the guest. This makes a VISO faster to create and use, and you do not need guest additions. A VISO is read-only and is ideal for use as installation media or reference data.</p>
     <ol>
       <li>
Index: trunk/doc/manual/en_US/dita/topics/efividmode.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/efividmode.dita	(revision 106219)
+++ trunk/doc/manual/en_US/dita/topics/efividmode.dita	(revision 106318)
@@ -5,328 +5,248 @@
   
   <body>
-    <p>EFI provides two distinct video interfaces: GOP (Graphics Output Protocol) and UGA (Universal Graphics Adapter).
-      Modern OSes, such as Mac OS X, generally use GOP, while some older ones still use UGA. <ph
-        conkeyref="vbox-conkeyref-phrases/product-name"/> provides a configuration option to control the graphics
-      resolution for both interfaces, making the difference mostly irrelevant for users. </p>
+    <p>EFI provides two distinct video interfaces: GOP (Graphics Output Protocol) and UGA (Universal Graphics Adapter). Modern OSes, such as Mac OS X, generally use GOP, while some older ones still use UGA. <ph conkeyref="vbox-conkeyref-phrases/product-name"/> provides a configuration option to control the graphics resolution for both interfaces, making the difference mostly irrelevant for users.</p>
     <p>The default resolution is 1024x768. To select a graphics resolution for EFI, use the following
         <userinput>VBoxManage</userinput> command: </p>
     <pre xml:space="preserve">VBoxManage setextradata "VM name" VBoxInternal2/EfiGraphicsResolution HxV</pre>
-    <p>Determine the horizontal resolution H and the vertical resolution V from the following list of default
-      resolutions: </p>
-    <dl>
-      <dlentry>
-        <dt>
-            VGA
-          </dt>
-        <dd>
-          <p>
-              640x480, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            SVGA
-          </dt>
-        <dd>
-          <p>
-              800x600, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            XGA
-          </dt>
-        <dd>
-          <p>
-              1024x768, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            XGA+
-          </dt>
-        <dd>
-          <p>
-              1152x864, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            HD
-          </dt>
-        <dd>
-          <p>
-              1280x720, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WXGA
-          </dt>
-        <dd>
-          <p>
-              1280x800, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            SXGA
-          </dt>
-        <dd>
-          <p>
-              1280x1024, 32bpp, 5:4
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            SXGA+
-          </dt>
-        <dd>
-          <p>
-              1400x1050, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WXGA+
-          </dt>
-        <dd>
-          <p>
-              1440x900, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            HD+
-          </dt>
-        <dd>
-          <p>
-              1600x900, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            UXGA
-          </dt>
-        <dd>
-          <p>
-              1600x1200, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WSXGA+
-          </dt>
-        <dd>
-          <p>
-              1680x1050, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            Full HD
-          </dt>
-        <dd>
-          <p>
-              1920x1080, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WUXGA
-          </dt>
-        <dd>
-          <p>
-              1920x1200, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            DCI 2K
-          </dt>
-        <dd>
-          <p>
-              2048x1080, 32bpp, 19:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            Full HD+
-          </dt>
-        <dd>
-          <p>
-              2160x1440, 32bpp, 3:2
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            Unnamed
-          </dt>
-        <dd>
-          <p>
-              2304x1440, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            QHD
-          </dt>
-        <dd>
-          <p>
-              2560x1440, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WQXGA
-          </dt>
-        <dd>
-          <p>
-              2560x1600, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            QWXGA+
-          </dt>
-        <dd>
-          <p>
-              2880x1800, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            QHD+
-          </dt>
-        <dd>
-          <p>
-              3200x1800, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WQSXGA
-          </dt>
-        <dd>
-          <p>
-              3200x2048, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            4K UHD
-          </dt>
-        <dd>
-          <p>
-              3840x2160, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WQUXGA
-          </dt>
-        <dd>
-          <p>
-              3840x2400, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            DCI 4K
-          </dt>
-        <dd>
-          <p>
-              4096x2160, 32bpp, 19:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            HXGA
-          </dt>
-        <dd>
-          <p>
-              4096x3072, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            UHD+
-          </dt>
-        <dd>
-          <p>
-              5120x2880, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WHXGA
-          </dt>
-        <dd>
-          <p>
-              5120x3200, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            WHSXGA
-          </dt>
-        <dd>
-          <p>
-              6400x4096, 32bpp, 16:10
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            HUXGA
-          </dt>
-        <dd>
-          <p>
-              6400x4800, 32bpp, 4:3
-            </p>
-        </dd>
-      </dlentry>
-      <dlentry>
-        <dt>
-            8K UHD2
-          </dt>
-        <dd>
-          <p>
-              7680x4320, 32bpp, 16:9
-            </p>
-        </dd>
-      </dlentry>
-    </dl>
-    <p>If this list of default resolution does not cover your needs, see <xref href="customvesa.dita">Custom VESA
-        Resolutions</xref>. Note that the color depth value specified in a custom video mode must be specified. Color
-      depths of 8, 16, 24, and 32 are accepted. EFI assumes a color depth of 32 by default. </p>
+    <p>Find the horizontal resolution H and the vertical resolution V from the following list of default resolutions: <table frame="all" rowsep="1" colsep="1">
+        <title>Default Resolutions for Display Types</title>
+        <desc>Common display types and their default resolution values.</desc>
+        <tgroup cols="5">
+          <colspec colname="c1" colnum="1" colwidth="1*"/>
+          <colspec colname="c2" colnum="2" colwidth="1.52*"/>
+          <colspec colname="c3" colnum="3" colwidth="1.37*"/>
+          <colspec colname="newCol4" colnum="4" colwidth="1.14*"/>
+          <colspec colname="c4" colnum="5" colwidth="1.22*"/>
+          <thead>
+            <row>
+              <entry>Display Type</entry>
+              <entry>Default Horizontal Resolution (px)</entry>
+              <entry>Default Vertical Resolution (px)</entry>
+              <entry>Color Depth (BPP)</entry>
+              <entry>Display Aspect Ratio</entry>
+            </row>
+          </thead>
+          <tbody>
+            <row>
+              <entry><b>VGA</b></entry>
+              <entry>640</entry>
+              <entry>480</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>SVGA</b></entry>
+              <entry>800</entry>
+              <entry>600</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>XGA</b></entry>
+              <entry>1024</entry>
+              <entry>768</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>XGA+</b></entry>
+              <entry>1152</entry>
+              <entry>864</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>HD</b></entry>
+              <entry>1280</entry>
+              <entry>720</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WXGA</b></entry>
+              <entry>1280</entry>
+              <entry>800</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>SXGA</b></entry>
+              <entry>1280</entry>
+              <entry>1024</entry>
+              <entry>32</entry>
+              <entry>5:4</entry>
+            </row>
+            <row>
+              <entry><b>SXGA+</b></entry>
+              <entry>1400</entry>
+              <entry>1050</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>WXGA+</b></entry>
+              <entry>1440</entry>
+              <entry>900</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>HD+</b></entry>
+              <entry>1600</entry>
+              <entry>900</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>UXGA</b></entry>
+              <entry>1600</entry>
+              <entry>1200</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>WSXGA+</b></entry>
+              <entry>1680</entry>
+              <entry>1050</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>Full HD</b></entry>
+              <entry>1920</entry>
+              <entry>1080</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WUXGA</b></entry>
+              <entry>1920</entry>
+              <entry>1200</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>DCI 2K</b></entry>
+              <entry>2048</entry>
+              <entry>1080</entry>
+              <entry>32</entry>
+              <entry>19:10</entry>
+            </row>
+            <row>
+              <entry><b>Full HD+</b></entry>
+              <entry>2160</entry>
+              <entry>1440</entry>
+              <entry>32</entry>
+              <entry>3:2</entry>
+            </row>
+            <row>
+              <entry><b>Unnamed</b></entry>
+              <entry>2304</entry>
+              <entry>1440</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>QHD</b></entry>
+              <entry>2560</entry>
+              <entry>1440</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WQXGA</b></entry>
+              <entry>2560</entry>
+              <entry>1600</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>QWXGA+</b></entry>
+              <entry>2880</entry>
+              <entry>1800</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>QHD+</b></entry>
+              <entry>3200</entry>
+              <entry>1800</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WQSXGA</b></entry>
+              <entry>3200</entry>
+              <entry>2048</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>4K UHD</b></entry>
+              <entry>3840</entry>
+              <entry>2160</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WQUXGA</b></entry>
+              <entry>3840</entry>
+              <entry>2400</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>DCI 4K</b></entry>
+              <entry>4096</entry>
+              <entry>2160</entry>
+              <entry>32</entry>
+              <entry>19:10</entry>
+            </row>
+            <row>
+              <entry><b>HXGA</b></entry>
+              <entry>4096</entry>
+              <entry>3072</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>UHD+</b></entry>
+              <entry>5120</entry>
+              <entry>2880</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+            <row>
+              <entry><b>WHXGA</b></entry>
+              <entry>5120</entry>
+              <entry>3200</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>WHSXGA</b></entry>
+              <entry>6400</entry>
+              <entry>4096</entry>
+              <entry>32</entry>
+              <entry>16:10</entry>
+            </row>
+            <row>
+              <entry><b>HUXGA</b></entry>
+              <entry>6400</entry>
+              <entry>4800</entry>
+              <entry>32</entry>
+              <entry>4:3</entry>
+            </row>
+            <row>
+              <entry><b>8K UHD2</b></entry>
+              <entry>7680</entry>
+              <entry>4320</entry>
+              <entry>32</entry>
+              <entry>16:9</entry>
+            </row>
+          </tbody>
+        </tgroup>
+      </table></p>
+    <p>If this list of default resolutions does not cover your needs, see <xref href="customvesa.dita">Custom VESA Resolutions</xref>. Note that the color depth value specified in a custom video mode must be specified. Color depths of 8, 16, 24, and 32 are accepted. EFI assumes a color depth of 32 by default. </p>
     <p>The EFI default video resolution settings can only be changed when the VM is powered off. </p>
   </body>
Index: trunk/doc/manual/en_US/dita/topics/vrde-crypt.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vrde-crypt.dita	(revision 106219)
+++ trunk/doc/manual/en_US/dita/topics/vrde-crypt.dita	(revision 106318)
@@ -7,14 +7,8 @@
     <p>RDP features data stream encryption, which is based on the RC4 symmetric cipher, with keys up to 128-bit. The RC4
       keys are replaced at regular intervals, every 4096 packets. </p>
-    <p>RDP provides the following different authentication methods: </p>
+    <p>RDP provides the following different server authentication methods: </p>
     <ul>
       <li>
-        <p><b outputclass="bold">RDP 4</b> authentication was
-            used historically. With RDP 4, the RDP client does not
-            perform any checks in order to verify the identity of the
-            server it connects to. Since user credentials can be
-            obtained using a man in the middle (MITM) attack, RDP4
-            authentication is insecure and should generally not be used.
-          </p>
+        <p><b outputclass="bold">RDP 4</b> authentication was used historically. With RDP 4, the RDP client does not perform any checks in order to verify the identity of the server it connects to. Since user credentials can be obtained using a man in the middle (MITM) attack, RDP4 authentication is insecure and should not be used. </p>
       </li>
       <li>
@@ -36,13 +30,8 @@
             certificate to the client.
           </p>
-        <p>The <codeph>Security/Method</codeph> VRDE property sets the required security method, which is used for a
-          connection. Valid values are as follows: </p>
+        <p>The <codeph>Security/Method</codeph> VRDE property sets the required security method that is used for a connection. You can also change this in the VM Settings, Remote Display tab. Valid values are as follows: </p>
         <ul>
           <li>
-            <p><b outputclass="bold">Negotiate.</b> Both
-                Enhanced (TLS) and Standard RDP Security connections are
-                allowed. The security method is negotiated with the
-                client. This is the default setting.
-              </p>
+            <p><b outputclass="bold">Negotiate.</b> Both Enhanced (TLS) and Standard RDP Security connections are allowed. The security method is negotiated with the client. </p>
           </li>
           <li>
@@ -52,7 +41,5 @@
           </li>
           <li>
-            <p><b outputclass="bold">TLS.</b> Only Enhanced RDP
-                Security is accepted. The client must support TLS.
-              </p>
+            <p><b outputclass="bold">TLS.</b> Only Enhanced RDP Security is accepted. The client must support TLS. This is the default setting. </p>
             <p>
                 The version of OpenSSL used by <ph conkeyref="vbox-conkeyref-phrases/product-name"/> supports
@@ -61,11 +48,9 @@
           </li>
         </ul>
-        <p>For example, the following command enables a client to use either Standard or Enhanced RDP Security
-          connection: </p>
-        <pre xml:space="preserve">vboxmanage modifyvm <varname>VM-name</varname> --vrde-property "Security/Method=negotiate"</pre>
-        <p>If the <codeph>Security/Method</codeph> property is set to either Negotiate or TLS, the TLS protocol will be
-          automatically used by the server, if the client supports TLS. However, in order to use TLS the server must
-          possess the Server Certificate, the Server Private Key and the Certificate Authority (CA) Certificate. The
-          following example shows how to generate a server certificate. </p>
+        <p>For example, the following command configures a client to use either Standard or Enhanced RDP Security connection: </p>
+        <pre xml:space="preserve">VBoxManage modifyvm <varname>VM-name</varname> --vrde-property "Security/Method=negotiate"</pre>
+        <p>If the <codeph>Security/Method</codeph> property is set to either Negotiate or TLS, the server uses TLS if the client supports it. However, to use TLS the server must have the Server Certificate and the Server Private Key. A Certificate Authority (CA) Certificate is optional. </p>
+        <p>If you choose TLS as the security method, <ph conkeyref="vbox-conkeyref-phrases/product-name"/> generates a server key and certificate pair called VRDEAutoGeneratedPrivateKey.pem and VRDEAutoGeneratedCert.pem) for the VM. <ph conkeyref="vbox-conkeyref-phrases/product-name"/> also recreates the auto-generated certificate and key if they are about to expire, or if one or both are deleted or corrupted. </p>
+        <p>To generate a custom server key and certificate pair, with a CA certificate, follow these steps. </p>
         <ol>
           <li>
@@ -85,11 +70,12 @@
           </li>
         </ol>
-        <p>The server must be configured to access the required files. For example: </p>
-        <pre xml:space="preserve">vboxmanage modifyvm <varname>VM-name</varname> \
+        <p>Configure the server to access the required files. For example: </p>
+        <pre xml:space="preserve">VBoxManage modifyvm <varname>VM-name</varname> \
   --vrde-property "Security/CACertificate=path/ca_cert.pem"</pre>
-        <pre xml:space="preserve">vboxmanage modifyvm <varname>VM-name</varname> \
+        <pre xml:space="preserve">VBoxManage modifyvm <varname>VM-name</varname> \
   --vrde-property "Security/ServerCertificate=path/server_cert.pem"</pre>
-        <pre xml:space="preserve">vboxmanage modifyvm <varname>VM-name</varname> \
+        <pre xml:space="preserve">VBoxManage modifyvm <varname>VM-name</varname> \
   --vrde-property "Security/ServerPrivateKey=path/server_key_private.pem"</pre>
+        <p>Note that <ph conkeyref="vbox-conkeyref-phrases/product-name"/> does not maintain custom certificates. You are responsible for keeping these updated.</p>
       </li>
     </ul>